package bookExamples.ch26Graphics.draw2d;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: Gino Lopes
 * Date: Feb 2, 2005
 * Time: 5:16:33 PM
 * To change this template use File | Settings | File Templates.
 */
public class ConeShape extends Shape {
    int x1 = 0;
    int y1 = 0;
    int x2 = 0;
    int w = 1;
    int h = 1;
    int xc = 0;
    int yc = 0;
    int coneHeight = 0;

    public Shape getInstance(int x1, int y1, int x2, int y2) {
        return new ConeShape(x1, y1, x2, y2);
    }

    public ConeShape(int _x1, int _y1, int _x2, int _y2) {
        super(_x1,_y1,_x2,_y2);
        x1 = _x1;
        y1 = _y1;
        w = Math.abs(_x2 - x1);
        h = Math.abs(_y2 - y1);
        if (_x1 > _x2) x1 = _x2;
        if (_y1 > _y2) y1 = _y2;
        xc = x1 + w / 2;
        yc = y1 + h / 2;
        coneHeight = yc - h;
        x2 = x1 + w;
    }

    public void paint(Graphics g) {
        g.drawOval(x1, y1, w, h);
        g.fillOval(xc, yc, 2, 2);
        g.drawLine(x1, yc, xc, coneHeight);
        g.drawLine(x2, yc, xc, coneHeight);
        g.drawString("(" + xc + "," + yc + ")", xc + 3, yc + 3);
        g.drawString("(" + xc + "," + h + ")", xc + 3, coneHeight + 3);
        g.drawString("(" + x1 + "," + yc + ")", x1 - 50, yc + 3);
        g.drawString("(" + x2 + "," + yc + ")", x2 + 3, yc + 3);
        g.drawString("Cone: width = " + w + ", height = " + coneHeight + ")", xc , coneHeight - 20);
    }
}// end class ConeShape
